MDOC(7)

NAME
mdoc - quick reference guide for the -mdoc macro package

SYNOPSIS
groff -mdoc files ...

DESCRIPTION
The -mdoc package is a set of content-based and domain-based macros used to format the BSD man pages. The macro names and their meanings are listed below for quick reference; for a detailed explanation on using the package, see the tutorial sampler mdoc.samples(7).

The macros are described in two groups, the first includes the structural and physical page layout macros. The second contains the manual and general text domain macros which differentiate the -oc package from other troff formatting packages.

PAGE STRUCTURE DOMAIN

  Title Macros
To create a valid manual page, these three macros, in this order, are required:
.Dd   Month day, year
    Document date.
.Dt   DOCUMENT_TITLE [section] [volume]
    Title, in upper case.
.Os   OPERATING_SYSTEM [version/release]
    Operating system (BSD).

  Page Layout Macros
Section headers, paragraph breaks, lists and displays.
.Sh Section Headers. Valid headers, in the order of presentation:
    NAME
        Name section, should include the ‘.Nm’ or ‘.Fn’ and the ‘.Nd’ macros.
    SYNOPSIS
        Usage.
    DESCRIPTION
        General description, should include options and parameters.
    RETURN VALUES
        Sections two and three function calls.
    ENVIRONMENT
        Describe environment variables.
    FILES
        Files associated with the subject.
    EXAMPLES
        Examples and suggestions.
    DIAGNOSTICS
        Normally used for section four device interface diagnostics.
    ERRORS
        Sections two and three error and signal handling.
    SEE ALSO
        Cross references and citations.
    STANDARDS
        Conformance to standards if applicable.
    HISTORY
        If a standard is not applicable, the history of the subject should be given.
    BUGS
        Gotchas and caveats.
    other
        Customized headers may be added at the authors discretion.
.Ss Subsection Headers.
.Pp Paragraph Break. Vertical space (one line).
.D1 (D-one) Display-one Indent and display one text line.
.Dl (D-ell) Display-one literal. Indent and display one line of literal text.
.Bd Begin-display block. Display options:
    -ragged
        Unjustified (ragged edges).
    -filled
        Justified.
    -literal
        Literal text or code.
    -file name
        Read in named file and display.
    -offset string
        Offset display. Acceptable string values:
        left
            Align block on left (default).
        center
            Approximate center margin.
        indent
            Six constant width spaces (a tab).
        indent-two
            Two tabs.
        right
            Left aligns block 2 inches from right.
        xxn Where xx is a number from 4n to 99n.
        Aa  Where Aa is a callable macro name.
        string
            The width of string is used.
.Ed End-display (matches .Bd).
.Bl Begin-list. Create lists or columns. Options:
    List-types
        -bullet | Bullet Item List
        -item | Unlabeled List
        -enum | Enumerated List
        -tag | Tag Labeled List
        -diag | Diagnostic List
        -hang | Hanging Labeled List
        -ohang | Overhanging Labeled List
        -inset | Inset or Run-on Labeled List
    List-parameters
        -offset
            (All lists.) See ‘.Bd’ begin-display above.
        -width
            (-tag and -hang lists only.) See ‘.Bd’.
        -compact
            (All lists.) Suppresses blank lines.
.El End-list.
.It List item.

MANUAL AND GENERAL TEXT DOMAIN MACROS
The manual and general text domain macros are special in that most of them are parsed for callable macros for example:

.Op Fl s Ar file
    Produces [-s file]

In this example, the option enclosure macro ‘.Op’ is parsed, and calls the callable content macro ‘-’ which operates on the argument ‘s’ and then calls the callable content macro ‘file ...’ which operates on the argument ‘file’. Some macros may be callable, but are not parsed and vice versa. These macros are indicated in the parsed and callable columns below.

Unless stated, manual domain macros share a common syntax:

    .Va argument [ . , ; : ( ) [ ] argument ... ]

Note: Opening and closing punctuation characters are only recognized as such if they are presented one at a time. The string ‘),’ is not recognized as punctuation and will be output with a leading white space and in what ever font the calling macro uses. The argument list ‘] ) ,’ is recognized as three sequential closing punctuation characters and a leading white space is not output between the characters and the previous argument (if any). The special meaning of a punctuation character may be escaped with the string ‘\&’. For example the following string,

.Ar file1 , file2 , file3 ) .
    Produces file1, file2, file3).

  Manual Domain Macros
Name Parsed Callable Description
 | Yes | Yes | Address. (This macro may be deprecated.)
 | Yes | Yes | Author name.
file ... | Yes | Yes | Command line argument.
 | | | Configuration declaration (section four only).
 | Yes | Yes | Command line argument modifier.
 | Yes | Yes | Defined variable (source code).
 | Yes | Yes | Error number (source code).
 | Yes | Yes | Environment variable.
 | Yes | Yes | Function argument.
Fd | Yes | Yes | Function declaration.
 | Yes | Yes | Function call (also .Fo and .Fc).
 | Yes | Yes | Interactive command.
 | Yes | Yes | Literal text.
mdoc | Yes | Yes | Command name.
[| Yes | Yes | Option (also .Oo and .Oc).]
 | Yes | Yes | Old style function type (Fortran only).
~ | Yes | Yes | Pathname or file name.
 | Yes | Yes | Standards (-p1003.2, -p1003.1 or -ansiC)
 | Yes | Yes | Variable name.
 | Yes | Yes | Variable type (Fortran only).
 | Yes | Yes | Manual Page Cross Reference.

  General Text Domain Macros
Name | Parsed | Callable | Description
%A | Yes | | Reference author.
%B | Yes | Yes | Reference book title.
%C | | | Reference place of publishing (city).
%D | | | Reference date.
%J | Yes | Yes | Reference journal title.
%N | | | Reference issue number.
%O | | | Reference optional information.
%P | | | Reference page number(s).
%R | | | Reference report Name.
%T | Yes | Yes | Reference article title.
%V | | | Reference volume.
> | Yes | Yes | Angle close quote.
<| Yes | Yes | Angle open quote.
'| Yes | Yes | Apostrophe.
<| Yes | Yes | Angle quote.>
AT&T UNIX | | | AT&T UNIX
] | Yes | Yes | Bracket close quote.
Bf | | | Begin font mode.
[| Yes | Yes | Bracket open quote.
[| Yes | Yes | Bracket quote.]
BSD | Yes | Yes | BSD.
Db | | | Debug (default is \*qoff\*q)
” | Yes | Yes | Double close quote.
“| Yes | Yes | Double open quote.
“| Yes | Yes | Double quote.”
 | Yes | Yes | Enclose string close quote.
Ef | | | End font mode.
 | Yes | Yes | Emphasis (traditional English).
 | Yes | Yes | Enclose string open quote.
FreeBSD | | | FreeBSD operating system
 | Yes | Yes | Normal text (no-op).
 | Yes | Yes | No space.
) | Yes | Yes | Parenthesis close quote.
 | Yes | | Prefix string.
(| Yes | Yes | Parenthesis open quote.
(| Yes | Yes | Parentheses quote.)
" | Yes | Yes | Strait Double close quote.
‘| Yes | Yes | Quoted literal.’
"| Yes | Yes | Strait Double open quote.
"| Yes | Yes | Strait Double quote."
Re | | | Reference start.
Rs | | | Reference start.
Rv | | | Return values (sections two and three only).
’ | Yes | Yes | Single close quote.
‘| Yes | Yes | Single open quote.
‘| Yes | Yes | Single quote.’
Sm | | | Space mode (default is \*qon\*q)
 | Yes | Yes | Section Cross Reference.
 | Yes | Yes | Symbolic (traditional English).
 | Yes | Yes | Trade or type name (small Caps).
UNIX | Yes | Yes | UNIX
 | Yes | Yes | Extend argument list close.
 | Yes | Yes | Extend argument list open.

Macro names ending in ‘q’ quote remaining items on the argument list. Macro names ending in ‘o’ begin a quote which may span more than one line of input and are close quoted with the matching macro name ending in ‘c’. Enclosure macros may be nested and are limited to eight arguments.

Note: the extended argument list macros (‘.Xo’, ‘.Xc’) and the function enclosure macros (‘.Fo’, ‘.Fc’) are irregular. The extended list macros are used when the number of macro arguments would exceed the troff limitation of nine arguments.

CONFIGURATION
For site specific configuration of the macro package, see the file /usr/src/share/tmac/README.

FILES
tmac.doc
    Manual and general text domain macros.
tmac.doc-common
    Common structural macros and definitions.
tmac.doc-nroff
    Site dependent nroff style file.
tmac.doc-ditroff
    Site dependent troff style file.
tmac.doc-syms
    Special defines (such as the standards macro).

SEE ALSO
mdoc.samples(7)